consoleLog('calendar_challenge_common.js');

var db;

var iTotalDays;
var dateNow;
var dateNowNoon;
var dateChallengeBegan;
var iCurrentDay;
var	iDayViewing;
var iArticleViewing;

function onPageLoad()
{
	consoleLog('onPageLoad()');

	db = window.localStorage;
	
	iTotalDays = 30;

	//only to reset
	//db.clear();

	//ga_storage._setAccount('UA-2171117-9');
	ga_storage._setAccount('UA-89402-105');
    ga_storage._trackPageview('calendar_challenge_main.html','AppStartup - ' + getPlatform());
	
	if(document.location.href.indexOf('#') != -1) {
		//coming in on a bum page, happens with wp8 coming back from an ad call
		history.go(-(history.length - 1));
	}

	//refresh the main page - day number especially - once and then once every 10 minutes (for if app is left in background for days - seems to be iOS only issue)
	refreshVarsAndMainPage();
	setInterval("refreshVarsAndMainPage();", (1000*60*10));
	
	//refreshAdsHomeForce();

	if(iCurrentDay <= iTotalDays){
		if(iCurrentDay == 1){
			setTimeout("gotoDay(iCurrentDay);",2000);
			//gotoDay(iCurrentDay);
		}
		else {
			setTimeout("gotoDay(iCurrentDay);",1000);
			//gotoDay(iCurrentDay);
		}
	}
	else {
		refreshAdsHome();
	}
}

function consoleLog(strParm)
{
	if ( window.console && window.console.log ) {
	  // console is available
		console.log(strParm);
	}
}

function bSupportsNotification()
{
	if(window)
		if(window.plugin)
			if(window.plugin.notification)
				return true;
				
	return false;
}

function days_between(date1, date2) {

	var oneDay = 24*60*60*1000; // hours*minutes*seconds*milliseconds
	var firstDate = new Date(date1);
	var secondDate = new Date(date2);

	var diffDays = Math.round(((firstDate.getTime() - secondDate.getTime())/(oneDay)));
	return diffDays;
}

function saveSelectedDay() {
	var iSelectedDay;
	iSelectedDay = document.getElementById("current_day").selectedIndex + 1;
	setCurrentDay(iSelectedDay);
	iCurrentDay = iSelectedDay;
	if(iCurrentDay <= iTotalDays){
		document.getElementById('current_day_number').innerHTML = iSelectedDay;
		document.getElementById('main_current_day_text').innerHTML = '';
		document.getElementById('main_current_day_number').innerHTML = 'You are in day ' + iCurrentDay;
	}
	else {
		document.getElementById('main_current_day_text').innerHTML = '';
		document.getElementById('main_current_day_number').innerHTML = 'You have completed the challenge';
	}
}

function clearDayCheckmarks() {
	for (i = 1; i <= iTotalDays; i++) {
		db.setItem('checked_day' + i, 0);
	}
	//document.getElementById('clear_day_checkmarks').disabled = true;
	document.getElementById('days_checked').innerHTML = "0";
	RefreshMainCalendar();
}

function setCurrentDay(iDay) {

	dateNow = new Date();
	dateNowNoon = new Date(dateNow.getFullYear(), dateNow.getMonth(), dateNow.getDate(), 12, 0, 0, 0);

	consoleLog('SSS set original date, iDay = ' + iDay);

	consoleLog('B dateNow = ' + dateNow);
	consoleLog('B dateNowNoon = ' + dateNowNoon);

	var dateTemp;
	dateTemp = new Date(dateNowNoon);
	dateTemp.setDate(dateNowNoon.getDate() - (iDay - 1));
	consoleLog('B dateTemp = ' + dateTemp);

	var dateNewChallengeBegan
	dateNewChallengeBegan = new Date(dateNowNoon);
	dateNewChallengeBegan.setDate(dateNowNoon.getDate() - (iDay - 1));
	consoleLog('B dateNewChallengeBegan = ' + dateNewChallengeBegan);

	db.setItem('date_challenge_began', dateTemp);

	if(bSupportsNotification()) {
		window.plugin.notification.local.cancelAll();		//first, cancel all, then if we need to add, we'll start from a blank slate

		window.plugin.notification.local.onclick = function (id, state, json) {
			gotoDay(id);
			//window.location='calendar_challenge_day' + id + '.html';
		}
	}

	var strTitle;
	var strNotification;
	var strNotificationLast;
	//var strNotificationMessageLast;
	//var strNotificationMessage;

	//strNotification = 'Day %day%';
	//strNotificationMessage = "This is the message."
	//strNotificationLast = 'LAST Day %day%';
	//strNotificationMessageLast = 'This is the LAST message.';

	strTitle = "30-Day Diet Makeover Challenge";
	if(getPlatform()=='ios'){
		//iOS shows the app name, and doesn't need the title
		strTitle = "";
	}
	strNotification = 'Day %day%: ';
	strNotificationLast = 'Day %day%: ';

	if (iDay < iTotalDays)
	{
		//temporary - 2 minute notification
		//dateTemp = addMinutes(dateNow, 2)
		//if((getPlatform()=='android')||(getPlatform()=='ios')){
		//	if(bSupportsNotification())
		//	{
		//		window.plugin.notification.local.add({
		//			id:      '' + iDay, // is converted to a string
		//			title:   strTitle,
		//			message: strNotification.replace("%day%", '' + iDay) + getDayHeadline(iDay),
		//			autoCancel: 'true',
		//			json:       JSON.stringify({ test: 123 }),
		//			date:    dateTemp
		//		});
		//	}
		//}
		//consoleLog('FIRST add notification for day ' + iDay + ', ' + dateTemp);
		//temporary - 2 minute notification
		
		for (i = (iDay + 1); i < iTotalDays; i++)
		{
			dateTemp = addDays(dateNewChallengeBegan, (i-1))
			
			//this was just testing - alerts minutes from now
			//dateTemp = addMinutes(dateNow, (i-iDay))


			if((getPlatform()=='android')||(getPlatform()=='ios')){
				if(bSupportsNotification())
				{
					window.plugin.notification.local.add({
						id:      '' + i, // is converted to a string
						title:   strTitle,
						message: strNotification.replace("%day%", '' + i) + getDayHeadline(i),
						autoCancel: 'true',
						json:       JSON.stringify({ test: 123 }),
						date:    dateTemp
					});
				}
			}
			consoleLog('add notification for day ' + i + ', ' + dateTemp);
		}
		dateTemp = addDays(dateNewChallengeBegan, (i-1))

		//this was just testing - alerts minutes from now
		//dateTemp = addMinutes(dateNow, (i-iDay))
		
		if((getPlatform()=='android')||(getPlatform()=='ios')){
			if(bSupportsNotification())
			{
				window.plugin.notification.local.add({
					id:      '' + i, // is converted to a string
					title:   strTitle,
					message: strNotificationLast.replace("%day%", '' + i) + getDayHeadline(i),
					autoCancel: 'true',
					json:       JSON.stringify({ test: 123 }),
					date:    dateTemp
				});
			}
		}
		consoleLog('add LAST notification for day ' + i + ', ' + dateTemp);
	}
}

function addDays(date, days) {
  var d2 = new Date(date);
  d2.setDate(d2.getDate() + days);
  return d2;
}

function addMinutes(date, minutes) {
    return new Date(date.getTime() + minutes*60000);
}

function getPlatform()
{
	if (isAndroid())
	{
		return 'android';
	}
	if (isIOS())
	{
		return 'ios';
	}
	if (isWP())
	{
		return 'wp';
	}
}

function isAndroid()
{
	return navigator.userAgent.match(/(Android)/);
}

function isIOS()
{
	return navigator.userAgent.match(/(iPhone|iPod|iPad)/);
}

function isWP()
{
	return navigator.userAgent.match(/(IEMobile)/);
}


function gotoDay(iDay)
{
	iDayViewing = iDay;
	fillObjectWithContentFromFile("#content_piece_day", 'calendar_challenge_day' + iDay + ".html");
	gotoContentSection("#day", { transition: "pop", allowSamePageTransition: true });
}

function gotoArticle(iArticle)
{
	iArticleViewing = iArticle;
	fillObjectWithContentFromFile("#content_piece_article", 'article' + iArticle + ".html");
	gotoContentSection("#article", { transition: "pop", allowSamePageTransition: true });
}

function gotoSettings()
{
	fillObjectWithContentFromFile("#content_piece_settings", 'calendar_challenge_settings.html');
	gotoContentSection("#settings", { transition: "pop", allowSamePageTransition: true });
	//consoleLog(document.getElementById("current_day").options[iCurrentDay - 1].text);
}

function fillObjectWithContentFromFile(strObj, strFile)
{

	$(strObj).html('');
	getContentFromFile(strFile, function(strReturn){
		$(strObj).html(strReturn);
	});
}

function getContentFromFile(strFile, functionCall)
{
	ga_storage._trackPageview('' + strFile, strFile + ' - ' + getPlatform());

	$.ajax({
        url : strFile,
        type : "get",
        success : function(data, textStatus, jqXHR) {
            functionCall(data);
        },
        error : function(jqXHR, textStatus, errorThrown) {
			$.ajax({
				url : 'www/' + strFile,
				type : "get",
				success : function(data, textStatus, jqXHR) {
					functionCall(data);
				},
				error : function(jqXHR, textStatus, errorThrown) {
					console.log('error loading data from ' + strFile + ':' + errorThrown);
					functionCall("");
				}
			});
        }
    });
}

function gotoContentSection(oSection, oOptions)
{
	if(oOptions)
	{
		oOptions.changeHash = true;
	}
	else
	{
		oOptions = {changeHash: true};
	}
	$( ":mobile-pagecontainer" ).pagecontainer( "change", oSection, oOptions);
	return false;
}


function checkDay(i) {
	consoleLog('checkDay()');
	consoleLog('i = ' + i);
	consoleLog('iiDayViewing = ' + iDayViewing);

	if (i != iCurrentDay) {
		RefreshGlobalVariables();
		RefreshMainCalendar();
	}

	if(db.getItem('checked_day' + i)){
		if((db.getItem('checked_day' + i))==1){
			document.getElementById('checked_day' + i).style.display="inline";
			document.getElementById('mark_day' + i).style.display="none";
			document.getElementById('unmark_day' + i).style.display="inline";
			consoleLog('checked_day' + i + ' inline.');
		}
		else {
			document.getElementById('checked_day' + i).style.display="none";
			document.getElementById('mark_day' + i).style.display="inline";
			document.getElementById('unmark_day' + i).style.display="none";
			consoleLog('checked_day' + i + ' none A.');
		}
	}
	else {
		db.setItem('checked_day' + i, 0);
		document.getElementById('checked_day' + i).style.display="none";
		document.getElementById('mark_day' + i).style.display="inline";
		document.getElementById('unmark_day' + i).style.display="none";
		consoleLog('checked_day' + i + ' none B.');
	}

	if(getPlatform()=='ios'){
		if(document.getElementById('view_ios_day' + i)){
			document.getElementById('view_ios_day' + i).style.display="inline";
		}
	}
	if(getPlatform()=='android'){
		if(document.getElementById('view_android_day' + i)){
			document.getElementById('view_android_day' + i).style.display="inline";
		}
	}
	if(getPlatform()=='wp'){
		if(document.getElementById('view_wp_day' + i)){
			document.getElementById('view_wp_day' + i).style.display="inline";
		}
	}
	if((getPlatform()!='ios')&&(getPlatform()!='android')&&(getPlatform()!='wp')){
		if(document.getElementById('view_else_day' + i)){
			document.getElementById('view_else_day' + i).style.display="inline";
		}
	}
}

function markDay(i) {
	db.setItem('checked_day' + i, 1);
	document.getElementById('checked_day' + i).style.display="inline";
	document.getElementById('mark_day' + i).style.display="none";
	document.getElementById('unmark_day' + i).style.display="inline";
	consoleLog('checked_day' + i + ' inline.');

	RefreshMainCalendar();
}
function unmarkDay(i) {
	db.setItem('checked_day' + i, 0);
	document.getElementById('checked_day' + i).style.display="none";
	document.getElementById('mark_day' + i).style.display="inline";
	document.getElementById('unmark_day' + i).style.display="none";
	consoleLog('checked_day' + i + ' none.');

	RefreshMainCalendar();
}

function RefreshMainCalendar() {

	//for testing only - seeing update times
	//document.getElementById('update_date').innerHTML = datenow();
	//document.getElementById('update_time').innerHTML = timenow();

	if(iCurrentDay <= iTotalDays){
		document.getElementById('main_current_day_text').innerHTML = '';
		document.getElementById('main_current_day_number').innerHTML = 'You are in day ' + iCurrentDay;
	}
	else {
		document.getElementById('main_current_day_text').innerHTML = '';
		document.getElementById('main_current_day_number').innerHTML = 'You have completed the challenge';
	}

	for (i = 1; i <= iTotalDays; i++) {
		if(db.getItem('checked_day' + i)){
			if((db.getItem('checked_day' + i))==1){
				document.getElementById('main_checked_day' + i).style.display="inline";
				//consoleLog('checked_day' + i + ' inline.');
			}
			else {
				document.getElementById('main_checked_day' + i).style.display="none";
				//consoleLog('checked_day' + i + ' none A.');
			}
		}
		else {
			db.setItem('checked_day' + i, 0);
			document.getElementById('main_checked_day' + i).style.display="none";
			//consoleLog('checked_day' + i + ' none B.');
		}
	}
}

function RefreshGlobalVariables() {
	dateNow = new Date();
	dateNowNoon = new Date(dateNow.getFullYear(), dateNow.getMonth(), dateNow.getDate(), 12, 0, 0, 0);
	dateChallengeBegan = new Date();

	consoleLog('dateNow = ' + dateNow);
	consoleLog('dateNowNoon = ' + dateNowNoon);

	if(db.getItem('date_challenge_began')){
		consoleLog('db.getItem(\'date_challenge_began\') = ' + db.getItem('date_challenge_began'));
		dateChallengeBegan=db.getItem('date_challenge_began');
		consoleLog('dateChallengeBegan = ' + dateChallengeBegan);
	}
	else {
		setCurrentDay(1);
	}

	iCurrentDay=days_between(dateNowNoon,dateChallengeBegan) + 1;
	consoleLog('iCurrentDay = ' + iCurrentDay);
}

function refreshAdsHomeForce()
{
	consoleLog('refreshAdsHomeForce()');
	document.getElementById('top_ad_home').src = 'top_ad_home.html';
	document.getElementById('bottom_ad_home').src = 'bottom_ad_home.html';
    ga_storage._trackPageview('calendar_challenge_main.html','refreshAdsHome() - ' + getPlatform());
}

function refreshAdsHome()
{
	consoleLog('refreshAdsHome()');
	if((getPlatform()=='android')||(getPlatform()=='ios')){
		document.getElementById('top_ad_home').src = 'top_ad_home.html';
	}
	document.getElementById('bottom_ad_home').src = 'bottom_ad_home.html';
    ga_storage._trackPageview('calendar_challenge_main.html','refreshAdsHome() - ' + getPlatform());
}

function refreshAdsDay()
{
	consoleLog('refreshAdsDay()');
	if((getPlatform()=='android')||(getPlatform()=='ios')){
		document.getElementById('top_ad_day').src = 'top_ad_day.html';
	}
	document.getElementById('bottom_ad_day').src = 'bottom_ad_day.html';
	RefreshGlobalVariables();
	RefreshMainCalendar();
}

function fixAdIFrame(strFrame)
{
	$(strFrame).one('load', function() {
		makeOpenWindowHref(strFrame);
	});
}

function makeOpenWindowHref(element) {
	if (bIsDevice()){
		$(element).contents().find('a[href^="http"]').each(function() {
		   $(this).click(function(event){
				event.preventDefault();
				window.open($(this).attr("href"), '_system');
			});
		});
	}
}

function bIsDevice()
{
	consoleLog("in bisdevice. url=" + document.URL + " val=" + document.URL.match(/(sparkpeople)/))
	return !document.URL.match(/(sparkpeople)/);
}

function refreshVarsAndMainPage()
{
	consoleLog('refreshVarsAndMainPage()');
	RefreshGlobalVariables();
	RefreshMainCalendar();
}

function datetimenow(){
    var now= new Date(), 
    ampm= 'am', 
    h= now.getHours(), 
    m= now.getMinutes(), 
    s= now.getSeconds();
    if(h>= 12){
        if(h>12) h -= 12;
        ampm= 'pm';
    }

    if(m<10) m= '0'+m;
    if(s<10) s= '0'+s;
    return now.toLocaleDateString()+ ' ' + h + ':' + m + ':' + s + ' ' + ampm;
}

function datenow(){
    var now= new Date(), 
    ampm= 'am', 
    h= now.getHours(), 
    m= now.getMinutes(), 
    s= now.getSeconds();
    if(h>= 12){
        if(h>12) h -= 12;
        ampm= 'pm';
    }

    if(m<10) m= '0'+m;
    if(s<10) s= '0'+s;
    return now.toLocaleDateString();
}

function timenow(){
    var now= new Date(), 
    ampm= 'am', 
    h= now.getHours(), 
    m= now.getMinutes(), 
    s= now.getSeconds();
    if(h>= 12){
        if(h>12) h -= 12;
        ampm= 'pm';
    }

    if(m<10) m= '0'+m;
    if(s<10) s= '0'+s;
    return h + ':' + m + ':' + s + ' ' + ampm;
}

function getDayHeadline(iDay)
{
	var strReturn;
	switch (iDay)
	{
		case 1: strReturn = "Welcome to the 30-Day Diet Makeover Challenge!"; break;
		case 2: strReturn = "Keep Your Eyes on the Prize"; break;
		case 3: strReturn = "A Mini Kitchen Makeover"; break;
		case 4: strReturn = "Common Portion Control Mistakes"; break;
		case 5: strReturn = "Stop Overeating with This Trick"; break;
		case 6: strReturn = "Bust Your Excuses to Eat Badly"; break;
		case 7: strReturn = "The Hunger Game"; break;
		case 8: strReturn = "Get This Week's Meal Plan"; break;
		case 9: strReturn = "Are You a Smart Snacker?"; break;
		case 10: strReturn = "Pull Your Sweet Tooth!"; break;
		case 11: strReturn = "Make Healthy Connections"; break;
		case 12: strReturn = "A New Drinking Game"; break;
		case 13: strReturn = "Don't Undo Your Workout with the Wrong Foods!"; break;
		case 14: strReturn = "Take Your Nutrition to the Next Level"; break;
		case 15: strReturn = "This Week's Free Meal Plan"; break;
		case 16: strReturn = "Choose These Healthy Convenience Foods"; break;
		case 17: strReturn = "Shake It Up to Keep It Off"; break;
		case 18: strReturn = "Eat Your Antioxidants"; break;
		case 19: strReturn = "Take Time Out for Your Food"; break;
		case 20: strReturn = "Eat Your Water: The Top Hydrating Foods"; break;
		case 21: strReturn = "Shortcuts to Squeeze In More Fruits and Veggies"; break;
		case 22: strReturn = "A Week's Worth of Fit Meals & Snacks"; break;
		case 23: strReturn = "Get Back on Track"; break;
		case 24: strReturn = "Veg Out!"; break;
		case 25: strReturn = "Treat Yourself"; break;
		case 26: strReturn = "Eating before a Workout"; break;
		case 27: strReturn = "Taste the Rainbow"; break;
		case 28: strReturn = "Morning Meals Made Easier"; break;
		case 29: strReturn = "Meals You'll Love to Eat"; break;
		case 30: strReturn = "Congratulations on Your 30-Day Diet Makeover!"; break;
		default: strReturn = "Congratulations!"; break;
	}
	return strReturn;
}
